
/*******************************************************************************
*
* File check1.c
*
* Copyright (C) 2014 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Connectivity of line lists.
*
*******************************************************************************/

#define MAIN_PROGRAM

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <limits.h>
#include "utils.h"
#include "contract.h"


int main(void)
{
   int nc,*nvc,**ivc;
   int nl,i,j;
   line_t *lnl;
   vsets_t vs;

   printf("\n");
   printf("Connectivity of line lists\n");
   printf("--------------------------\n\n");

   printf("Specify number of vertex clusters: ");
   (void)scanf("%d",&nc);

   nvc=malloc(nc*sizeof(*nvc));
   ivc=malloc(nc*sizeof(*ivc));
   error((nvc==NULL)||(ivc==NULL),1,"main [check1.c]",
         "Unable to allocate auxiliary arrays");

   for (i=0;i<nc;i++)
   {
      printf("Cluster no %d:\n",i);
      printf("Number of vertices = ");
      (void)(scanf("%d",nvc+i));

      ivc[i]=malloc(nvc[i]*sizeof(**ivc));
      error(ivc[i]==NULL,1,"main [check1.c]",
            "Unable to allocate auxiliary arrays");

      printf("Indices of the vertices (%d values) = ",nvc[i]);

      for (j=0;j<nvc[i];j++)
         (void)(scanf("%d",ivc[i]+j));
   }

   vs.ns=nc;
   vs.nv=nvc;
   vs.iv=ivc;

   printf("\n");

   while(1)
   {
      printf("Specify line list:\n");
      printf("Number of lines = ");
      (void)(scanf("%d",&nl));

      lnl=malloc(nl*sizeof(*lnl));
      error(lnl==NULL,1,"main [check1.c]",
            "Unable to allocate auxiliary arrays");

      printf("Lines [i1,i2 i3,i4 ..] (%d vertex pairs) = ",nl);

      for (i=0;i<nl;i++)
      {
         lnl[i].type=SCALAR;

         if (i==0)
            (void)(scanf("%d,%d",lnl[i].iv,lnl[i].iv+1));
         else
            (void)(scanf("%d,%d",lnl[i].iv,lnl[i].iv+1));
      }

      if (lnlcon(&vs,nl,lnl)==1)
         printf("Diagram is connected\n\n");
      else
         printf("Diagram is disconnected\n\n");
   }

   exit(0);
}
