
/*******************************************************************************
*
* File check1.c
*
* Copyright (C) 2015 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Simple checks of the programs bcount(), binsert() and bsubset().
*
*******************************************************************************/

#define MAIN_PROGRAM

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "utils.h"
#include "vxfcts.h"


int main(void)
{
   int n;
   unsigned int x[3],y[3];

   printf("\n");
   printf("Check of the programs bcount(), binsert() and bsubset()\n");
   printf("-------------------------------------------------------\n\n");

   n=(int)(8*sizeof(unsigned int));
   printf("Numbers of type 'unsigned int' have %d bits\n\n",n);

   y[0]=0x6A3u;     /* 0110 1010 0011 */
   y[1]=0x954u;     /* 1001 0101 0100 */
   y[2]=0xD345A987; /* 1101 0011 0100 0101 1010 1001 1000 0111 */

   printf("bcount()   = %d, %d, %d\n",
          bcount(12,y[0]),bcount(12,y[1]),bcount(32,y[2]));
   printf("(should be = 6, 5, 16)\n\n");

   x[0]=0xB;       /* 1011 */
   x[1]=0x1E;      /* 0001 1110 */
   x[2]=0x47CF;    /* 0100 0111 1100 1111 */

   printf("binsert()  = %#X, %#X, %#X\n",
          binsert(12,x[0],y[0]),binsert(12,x[1],y[1]),binsert(32,x[2],y[2]));
   printf("(should be = 0X6EF, 0X9FE, 0XDB5FF9FF)\n\n");

   printf("bsubset()  = %#X, %#X, %#X\n",
          bsubset(12,x[0],y[0]),bsubset(12,x[1],y[1]),bsubset(32,x[2],y[2]));
   printf("(should be = 0X83, 0X950, 0X4045A087)\n\n");

   printf("Check of the Bernoulli numbers:\n");

   while (1)
   {
      printf("Specify n: ");
      (void)(scanf("%d",&n));
      printf("Bn = % .15e\n",bernoulli(n));
   }

   exit(0);
}
